package net.xinhuamm.xycloud.xinhuamm_xycloud;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.io.UnsupportedEncodingException;
import java.lang.reflect.Type;
import java.net.URLEncoder;
import java.util.Map;
import java.util.Set;

/**
 * 对象参数转化为 Map类型的参数，然后在Retrofit 中使用Map的方式提交参数
 */
public class ClassToMap {

    public static Map<String, String> objectToMap(Object obj) {

        Gson gson = new Gson();
        String str = gson.toJson(obj);
        Type type = new TypeToken<Map<String, String>>() {
        }.getType();
        Map<String, String> map = gson.fromJson(str, type);
        //urlEncode2Values(map);
        return map;
    }

    public static void urlEncode2Values(Map<String, String> map) {
        if (map == null || map.size() == 0)
            return;

        Set<String> keys = map.keySet();
        for (String k : keys) {
            if (map.get(k) != null && !"".equals(map.get(k))) {
                try {
                    map.put(k, URLEncoder.encode(map.get(k), "utf-8"));
                } catch (UnsupportedEncodingException e) {
                    e.printStackTrace();
                }
            }
        }
    }

}
