package net.xinhuamm.xycloud.xinhuamm_xycloud

import android.content.Context
import android.content.ContextWrapper
import androidx.fragment.app.FragmentActivity
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.StandardMessageCodec
import io.flutter.plugin.platform.PlatformView
import io.flutter.plugin.platform.PlatformViewFactory

/**
 * author : yuntong
 * date   : 2023/11/17 16:00
 * desc   :
 */
class XYCloudWebViewFactory(private val messenger: BinaryMessenger) :
    PlatformViewFactory(StandardMessageCodec.INSTANCE) {

    override fun create(context: Context, viewId: Int, args: Any?): PlatformView {
        val activity: FragmentActivity? = findActivity(context)
        activity?.let {
            return XYCloudWebView(activity, messenger, viewId, args)
        }
        return XYCloudErrorView(context, args)
    }

    private fun findActivity(context1: Context): FragmentActivity? {
        var context = context1
        while (context is ContextWrapper) {
            if (context is FragmentActivity) {
                return context
            }
            context = context.baseContext
        }
        return null
    }
}
