//
//  XYCloudManager.h
//  xinhuamm_xycloud
//
//  Created by 邓付磊 on 2023/10/30.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <XYCMO2OModule/XYCMO2OModule.h>

@protocol XYCloudManagerDelegate <NSObject>

/// 公有云获取token - 替换免登逻辑 - 参考XYWebViewJSBridgeManager
/// 
- (void)getCloudTokenWith:(NSDictionary *)parameters block:(void(^)(NSDictionary *data))block;

/// 获取用户信息
- (void)getUserInfoWith:(NSDictionary *)parameters block:(void(^)(NSDictionary *data))block;

/// 分享
/// @param shareDic 分享参数：{"title":"标题", "description":"描述", "url":"链接",  "imageUrl":"分享图片",  "minPath":"小程序路径", "minId":"小程序id", "minType":2}
/// @param getPosterBlock 获取海报block，如果调用了 native 调用js 获取海报的方法
- (void)shareWithParameter:(NSDictionary *)shareDic getPosterBlock:(void (^)(BOOL))getPosterBlock;

@end


@interface XYCloudManager : NSObject
/// url
@property (nonatomic, copy)   NSString *url;
/// 登陆用户的id
@property (nonatomic, copy)   NSString *userId;
/// 登陆用户的phone
@property (nonatomic, copy)   NSString *phone;
/// 允许外部设置O2OController页面的frame
@property (nonatomic, assign) CGRect o2oViewFrame;
///// 是否展示导航条，公有云需要展示o2o 不需要，默认 NO；
@property (nonatomic, assign) BOOL showNavigationBar;
/// 代理
@property (nonatomic, weak)   id delegate;

+ (instancetype)managerWithUrl:(NSString *)url;

- (XYO2OModule *)setupMoudle;

/// 进入O2O页面
/// - Parameters:
///   - controller: 从哪个控制器跳转，如果为nil的话默认是rootViewController
///   - isPush: YES & controller.navigationController 存在，使用push方式，反之Model
- (void)enterO2OPageFromController:(UIViewController *)controller isPush:(BOOL)isPush;

@end

