import 'dart:ffi';

import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'xinhuamm_xycloud_method_channel.dart';
import 'package:flutter/services.dart';

abstract class XinhuammXycloudPlatform extends PlatformInterface {
  /// Constructs a XinhuammXycloudPlatform.
  XinhuammXycloudPlatform() : super(token: _token);

  static final Object _token = Object();

  static XinhuammXycloudPlatform _instance = MethodChannelXinhuammXycloud();

  /// The default instance of [XinhuammXycloudPlatform] to use.
  ///
  /// Defaults to [MethodChannelXinhuammXycloud].
  static XinhuammXycloudPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [XinhuammXycloudPlatform] when
  /// they register themselves.
  static set instance(XinhuammXycloudPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  void openCloudPage(String url) {
    throw UnimplementedError('openCloudPage() has not been implemented.');
  }

  Future<String> openScanPage() {
    throw UnimplementedError('openScanPage() has not been implemented.');
  }

  Future<bool> handleScanResult(String scanResult) {
    throw UnimplementedError('handleScanResult() has not been implemented.');
  }

  void setCloudGlobalConfig(config) {
    throw UnimplementedError(
        'setCloudGlobalConfig() has not been implemented.');
  }

  void setCloudMethodCallHandler(
      Future<dynamic> Function(MethodCall call)? handler) {
    throw UnimplementedError(
        'setCloudMethodCallHandler() has not been implemented.');
  }
}
